#ifndef _PARSE_MOUNT_H
#define _PARSE_MOUNT_H
#include <sys/mount.h>

typedef struct {
	char *opt;
	char *notopt;
	char *desc;
	unsigned int val;
} MU_MOUNT_OPTS;

static MU_MOUNT_OPTS mu_options[] = {
	{"defaults", NULL,     NULL, 0},
	{"ro",       "rw",     "Read only / Read and write", MS_RDONLY},
	{"remount",  NULL,     "Remount a mounted filesystem", MS_REMOUNT},
	{"sync",     "async",  "Writes are [a]synchronous", MS_SYNCHRONOUS},
	{"nodev",    "dev",    "(Dis)allow use of special device files", MS_NODEV},
	{"bind",     "rbind",  "Bind a file or directory", MS_BIND},
	{"noexec",   "exec",   "(Dis)allow use of executable files", MS_NOEXEC},
	{"noatime",  "atime",  "Disable/enable updates to inode access times", MS_NOATIME}
};

unsigned long mu_parse_opts(char *str, char *data, const size_t data_size);
#endif
